/* -*- Mode: C++ -*- */

/*
 *Copyright:

    Copyright (C) 1996-2000 Electrotechnical Laboratory. 
    	Itsuki Noda, Yasuo Kuniyoshi and Hitoshi Matsubara.
    Copyright (C) 2000, 2001 RoboCup Soccer Server Maintainance Group.
    	Patrick Riley, Tom Howard, Daniel Polani, Itsuki Noda,
	Mikhail Prokopenko, Jan Wendler 

    This file is a part of SoccerServer.

    This code is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

#ifndef _GZFSTREAM_H_
#define _GZFSTREAM_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_LIBZ


#include <zlib.h>
#include <iostream>
#include <strstream>

using namespace std;

class ogzfstream
  : public ostream
{
public:
  ogzfstream () 
    : ostream ( &__buffer ),
    __my_file ( NULL )
 { }
  
  void open ( const char* path, 
	      int level = Z_DEFAULT_COMPRESSION,
	      int strategy = Z_DEFAULT_STRATEGY );

  void open ( int fd,
	      int level = Z_DEFAULT_COMPRESSION,
	      int strategy = Z_DEFAULT_STRATEGY );

  void close ();

  ostream& write ( const char* str , streamsize n );
  
  gzFile gzfile() { return __my_file; }
  bool is_open () { return __my_file != NULL; }

  int setParams ( int level = Z_DEFAULT_COMPRESSION,
		  int strategy = Z_DEFAULT_STRATEGY );

  z_off_t seek ( z_off_t offset, int whence );
  z_off_t tell ();
  int flush ( int flush_type );
  void flush ();

protected:
  strstreambuf __buffer;
  gzFile __my_file;
};

#endif //HAVE_LIBZ

#endif 
