/* -*- Mode: C++ -*- */
/*
 *Copyright:

    Copyright (C) 2001 RoboCup Soccer Server Maintainance Group.
    	Patrick Riley, Tom Howard, Itsuki Noda,	Mikhail Prokopenko, Jan Wendler 

    This file is a part of SoccerServer.

    This code is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */
/* NOTE: This program is still under developement and is intended only to as a
   pre-release version provided to allow people to preview the coach language and
   semantics a bit.
*/
#include <iostream.h>
#include "coach_lang.h"
#include "garbage.h"

CM_Message* g_pMess = NULL;
//CM_Directive* pTesting = NULL;
//CM_Condition* pTesting = NULL;
CM_Token* pTesting = NULL;
const int max_mess_len = 2048;
char current_coach_message[max_mess_len];
GarbageCollector g_GC; 
int yyparse();
int yylex();
extern "C" {
  int parse_coach_lang_string(char*);
}

int main (int argc, char** argv) 
{
  //#define SET_TEST
#ifdef SET_TEST
  UnumSet s;
  int x;
  
  while (cin >> x) {
    if (x >= 0)
      s.addNum(x);
    else
      s.removeNum(-x);
    cout << s << endl;
  }
  
#endif	
#define PARSE_TEST
#ifdef PARSE_TEST
  int ret;

  while (cin) {
    //cout << "reading line" << endl;
    cin.getline(current_coach_message, max_mess_len);
    ret = parse_coach_lang_string(current_coach_message);
    //cout << "Parsing finished\n";
    g_GC.remove(g_pMess, GCE_pMess);
    g_GC.deleteAll();
    cout << "return value: " << ret << endl;
    if (g_pMess == NULL) {
      cout << " *No message read" << endl;
    } else {
      cout << " *";
      g_pMess->Print(cout);
      cout << endl;
    }
    if (pTesting != NULL) {
      cout << " *";
      pTesting->Print(cout);
      //cout << ((pTesting->eval()) ? "true" : "false");
      cout << endl;
    }
  }

  return ret;
#else

  int lexval;
  while ((lexval=yylex()) > 0) {
    cout << "token: " << lexval << endl;
  }
#endif
}
